/*
 * vivi/arch/s3c2410/mport3.c
 *
 * Copyright (C) 2002 MIZI Research, Inc.
 *
 * Author: Janghoon Lyu <nandy@mizi.com>
 * Date  : $Date: 2003/03/26 20:33:58 $
 *
 * $Revision: 1.3 $
 *
 * This file is subject to the terms and conditions of the CNU General Public
 * License. See the file COPYING in the main directory of this archive
 * for more details
 */

#include "config.h"
#include "machine.h"
#include "vivi.h"
#include "priv_data.h"
#include "mtd/map.h"
#include "boot_kernel.h"
#include "command.h"
#include "time.h"

mtd_partition_t default_mtd_partitions[] = { // 64M
	{
		name:		"vivi",
		offset:		0,
		size:		0x00020000, // 128K
		flag:		0
	}, {
		name:		"param",  // 64K
		offset:		0x00020000,
		size:		0x00010000,
		flag:		0
	}, {
		name:		"kernel", // 832K  :  bon/1
		offset:		0x00030000,
		size:		0x000D0000,
		flag:		0
	}, {
		name:		"root", //  1968K  :  bon/2
		offset:		0x00100000,
		size:		0x001ec000,
		flag:		MF_BONFS
	}, {
		name:		"module", // 80K : bon/3
		offset:		0x002ec000,
		size:		0x00014000,
		flag:		MF_BONFS
	}, {
		name:       "disp", // 16M : bon/4
        offset:     0x00300000,
        size:       0x01000000,
        flag:       MF_BONFS
    }, {
        name:       "rp", // 16M : bon/5
        offset:     0x01300000,
        size:       0x01000000,
        flag:       MF_BONFS
    }, {
        name:       "bmp", // 16M : bon/6 (/mtdblock/1)
        offset:     0x02300000,
        size:       0x01000000,
        flag:       MF_BONFS // fake
    }, {
        name:       "usr", // ? k : bon/7 (/mtdblock/2)
        offset:     0x03300000,
        size:       0x00cfc000,
        flag:       MF_BONFS // fake
	}
};
int default_nb_part = ARRAY_SIZE(default_mtd_partitions);

vivi_parameter_t default_vivi_parameters[] = {
	{ "mach_type",			MACH_TYPE,	NULL },
	{ "media_type",			MT_SMC_S3C2410,	NULL },
	{ "boot_mem_base",		0x30000000,	NULL },
	{ "baudrate",			UART_BAUD_RATE,	NULL },
	{ "xmodem",			1,		NULL },
	{ "xmodem_one_nak",		0,		NULL },
	{ "xmodem_initial_timeout",	300000,		NULL },
	{ "xmodem_timeout",		3000000,	NULL },
	{ "boot_delay",			0x0001000,	NULL }
};
int default_nb_params = ARRAY_SIZE(default_vivi_parameters);

char linux_cmd[] = "noinitrd panic=1 root=/dev/bon/2 init=/linuxrc console=ttyS0";

void set_vpp(struct map_info *map, int vpp)
{
}

void set_gpios(void)
{
	GPACON  = vGPACON;
	GPADAT  = vGPADAT;
	GPBCON  = vGPBCON;
	GPBUP   = vGPBUP; 
	GPBDAT  = vGPBDAT;
	GPCCON  = vGPCCON;
	GPCUP   = vGPCUP; 
	GPCDAT  = vGPCDAT;
	GPDCON  = vGPDCON;
	GPDUP   = vGPDUP; 
	GPDDAT  = vGPDDAT;
	GPECON  = vGPECON;
	GPEUP   = vGPEUP; 
	GPEDAT  = vGPEDAT;
	GPFCON  = vGPFCON;
	GPFUP   = vGPFUP; 
	GPFDAT  = vGPFDAT;
	GPGCON  = vGPGCON;
	GPGUP   = vGPGUP; 
	GPGDAT  = vGPGDAT;
	GPHCON  = vGPHCON;
	GPHUP   = vGPHUP; 
	GPHDAT  = vGPHDAT;
	EXTINT0 = vEXTINT0;
	EXTINT1 = vEXTINT1;
	EXTINT2 = vEXTINT2;
}

int board_init(void)
{
	init_time();
	set_gpios();

	return 0;
}

extern user_command_t cpu_cmd;
int misc(void)
{
	add_command(&cpu_cmd);
	return 0;
}
