/*
 * vivi/arch/sa1100/gill.c:
 *
 * This code is GPL
 *
 * Author: Janghoon Lyu <nandy@mizi.com>
 * Date  : $Date: 2002/08/21 06:39:00 $
 *
 * $Revision: 1.5 $
 * $Id: gill.c,v 1.5 2002/08/21 06:39:00 nandy Exp $
 * 
 */

#include "config.h"
#include "machine.h"
#include "hardware.h"
#include "priv_data.h"
#include "command.h"
#include "mtd/map.h"
#include "boot_kernel.h"
#include "vivi.h"
#include "time.h"

mtd_partition_t default_mtd_partitions[] = {
	{
		name:		"vivi",
		offset:		0,
		size:		0x00040000,
		flag:		0
	}, {
		name:		"param",
		offset:		0x00040000,
		size:		0x00040000,
		flag:		0
	}, {
		name:		"kernel",
		offset:		0x00080000,
		size:		0x000C0000,
		flag:		0
	}, {
		name:		"root",
		offset:		0x00140000,
		size:		0x00140000,
		flag:		0
	}, {
		name:		"usr",
		offset:		0x00280000,
		size:		0x01d80000,
		flag:		MF_JFFS2
	}
};
int default_nb_part = ARRAY_SIZE(default_mtd_partitions);

vivi_parameter_t default_vivi_parameters[] = {
	{ "mach_type",			MACH_TYPE,	NULL }, 
	{ "media_type",			MT_NOR_FLASH,	NULL },
	{ "boot_mem_base",		0xC0000000,	NULL }, 
	{ "baudrate",			UART_BAUD_RATE,	NULL }, 
	{ "xmodem",			1,		NULL },
	{ "xmodem_one_nak",		0,		NULL },
	{ "xmodem_initial_timeout",	300000,		NULL },
	{ "xmodem_timeout",		10000000,	NULL },
	{ "boot_delay",			0x1000000,	NULL }
};
int default_nb_params = ARRAY_SIZE(default_vivi_parameters);

char linux_cmd[] = "noinitrd root=/dev/mtdblock3 init=/linuxrc console=ttySA0";

void set_vpp(struct map_info *map, int vpp)
{
}

void set_gpios(void)
{
}

int board_init(void)
{
	init_time();
	set_gpios();

	GILL_BCR = GILL_BCR_DB1110;

	return 0;
}

int misc(void)
{
	return 0;
}
