/*
 * vivi/arch/sa1100/wismo.c:
 *
 * This code is under GPL.
 *
 * $Id: wismo.c,v 1.1 2002/11/19 10:50:54 cgjeong Exp $
 * 
 */

#include "config.h"
#include "machine.h"
#include "hardware.h"
#include "priv_data.h"
#include "command.h"
#include "mtd/map.h"
#include "boot_kernel.h"
#include "vivi.h"
#include "time.h"

#undef ADELLINUX // to boot adel linux kernel

mtd_partition_t default_mtd_partitions[] = {
#ifdef ADELLINUX
	{
		name:		"vivi",
		offset:		0,
		size:		0x00040000,
		flag:		0
	}, {
		name:		"param",
		offset:		0x00040000,
		size:		0x000c0000,
		flag:		0
	}, {
		name:		"kernel",
		offset:		0x00100000,
		size:		0x00100000,
		flag:		0
	}, {
		name:		"initrd",
		offset:		0x00200000,
		size:		0x00100000,
		flag:		0
	}, {
		name:		"usr",
		offset:		0x00300000,
		size:		0x00d00000,
		flag:		MF_JFFS2
	}
#else
	{
		name:		"vivi",
		offset:		0,
		size:		0x00040000,
		flag:		0
	}, {
		name:		"param",
		offset:		0x00040000,
		size:		0x00040000,
		flag:		0
	}, {
		name:		"kernel",
		offset:		0x00080000,
		size:		0x000C0000,
		flag:		0
	}, {
		name:		"root",
		offset:		0x00140000,
		size:		0x00140000,
		flag:		0
	}, {
		name:		"usr",
		offset:		0x00280000,
		size:		0x00d80000,
		flag:		MF_JFFS2
	}
#endif
};
int default_nb_part = ARRAY_SIZE(default_mtd_partitions);

vivi_parameter_t default_vivi_parameters[] = {
#ifdef ADELLINUX
	{ "mach_type",			31,	NULL }, 
#else
	{ "mach_type",			MACH_TYPE,	NULL }, 
#endif
	{ "media_type",			MT_NOR_FLASH,	NULL },
	{ "boot_mem_base",		0xC0000000,	NULL }, 
	{ "baudrate",			UART_BAUD_RATE,	NULL }, 
	{ "xmodem",			1,		NULL },
	{ "xmodem_one_nak",		0,		NULL },
	{ "xmodem_initial_timeout",	300000,		NULL },
	{ "xmodem_timeout",		10000000,	NULL },
	{ "boot_delay",			0x1000000,	NULL }
};
int default_nb_params = ARRAY_SIZE(default_vivi_parameters);

#ifdef ADELLINUX
char linux_cmd[] = "initrd=0x200000,0x100000 root=/dev/ram0 console=ttySA0";
#else
char linux_cmd[] = "noinitrd root=/dev/mtdblock3 init=/linuxrc console=ttySA0";
#endif

void set_vpp(struct map_info *map, int vpp)
{
}

void set_gpios(void)
{
}

int board_init(void)
{
	init_time();
	set_gpios();

	WISMO_PCR = WISMO_PCR_INIT;

	return 0;
}

int misc(void)
{
	return 0;
}
